/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

auto_enddecl ()  /* loops over table and sets automatic attribute */
{
	T_Entry *entry;
	Node *sublist;

	for_TABLE_LOOP (entry)
		if (IS_array (entry))
			if ((sublist = ENTRY_SUBLIST (entry)) != NN)
				if (!IS_argument (entry) && expr_sublist_not_constant (sublist)) {
					SET_automatic (entry);
				}
}

auto_write_decl (node)  /* given NAME Node for auto, writes as needed for declaration */
Node *node;
{
	onam (node->com.str);
	ostr ("(1)");
}

auto_write_arg (node)  /* given NAME Node for auto, writes as needed for argument */
Node *node;
{
	onam (node->com.str);
	ochb ('(');
	onam (auto_name (node->com.str));
	ochb (')');
}

char *auto_name (name)  /* $name_auto */
char *name;
{
    char *str;
	char *tname;
	T_Entry *entry;

	if ((entry = lookup_all (name)) == TN)
		SYSERR;

	tname = entry->orig_name;

    str = (char*) U_malloc (strlen (tname) + 1 + 5 + 1);
    strcpy (str, "$");
    strcat (str, tname);
    strcat (str, "_auto");

    return str;
}

auto_decl ()  /* declares extra variables to deal with automatic and alloc_temp arrays */
{
    int first = 1;
    T_Entry *entry;

    for_TABLE_LOOP (entry)
        if (IS_automatic (entry) || IS_alloc_temp (entry))
            if (first) {
                first = 0;
				otab ();
				oINTEGER ();
                onam (auto_name (entry->orig_name));
            }
            else {
                ochb (',');
                onam (auto_name (entry->orig_name));
            }

	if (first == 0) {
		odon ();
		otab ();
		oINTEGER ();
		onam ("@fmalloc");
		odon ();
	}
}

Node **list_alloc (num)
int num;
{
	return (Node**) U_malloc (sizeof (Node*) * num);
}

Node *auto_ffree_entry (entry)  /* CallStmt to free ... */
T_Entry *entry;
{
	Node *stmt, *dumlist;
	Node **list;

	list = list_alloc (9);

	list[0] = &Call;
	list[1] = make_Name ("@ffree");
	list[2] = &Lp;
	list[3] = make_Name (auto_name (entry->orig_name));
	list[4] = &Comma;
	list[5] = make_Name (entry->orig_name);
	list[6] = &Comma;
	list[7] = make_IntegerConstant (etype_size (entry->typ->etype));
	list[8] = &Rp;

	dumlist = make_DumList (9, list);
	stmt = make_DumStmt (make (CALL_STMT), dumlist);

	return stmt;
}

Node *auto_fmalloc_entry (entry)  /* FunctionReference to alloc ... */
T_Entry *entry;
{
	Node *stmt, *dumlist;
	Node **list;

	list = (Node**) U_malloc (sizeof (Node*) * 10);
	list [0] = make_Name (auto_name (entry->orig_name));
	list [1] = &Eq;
	list [2] = make_Name ("@fmalloc");
	list [3] = &Lp;
	list [4] = typ_shape_size (entry->typ->shape);
	list [5] = &Comma;
	list [6] = make_Name (entry->orig_name);
	list [7] = &Comma;
	list [8] = make_IntegerConstant (etype_size (entry->typ->etype));
	list [9] = &Rp;

	dumlist = make_DumList (10, list);
	stmt = make_DumStmt (make (ASSIGNEMENT_STMT), dumlist);

	return stmt;
}

auto_init ()  /* initialization code for automatics */
{
	T_Entry *entry;

	for_TABLE_LOOP (entry)
		if (IS_automatic (entry) && !IS_temporary (entry)) {
			ostart ();
			otab ();
			write_pass (auto_fmalloc_entry (entry));
			odon ();
			oend ();
		}
}

auto_end_write ()  /* free for automatics */
{
	T_Entry *entry;

	for_TABLE_LOOP (entry)
		if (IS_automatic (entry) && !IS_temporary (entry) &&!IS_result (entry)) {
			ostart ();
			otab ();
			write_pass (auto_ffree_entry (entry));
			odon ();
			oend ();
		}
}

auto_end ()  /* installs... */
{
	T_Entry *entry, *new_entry;
	Node *sublist;

	for_TABLE_LOOP (entry)
		if (IS_array (entry))
			if ((sublist = ENTRY_SUBLIST (entry)) != NN)
				if (!IS_argument (entry) && expr_sublist_not_constant (sublist)) {
					new_entry = install_loc (auto_name (entry->orig_name)
					, TAB_NAME, 0);
					new_entry->typ = typ_malloc ();
					new_entry->typ->etype = Etype_INTEGER_0;
					SET_temporary (new_entry);
				}
}
